<template>
  <div>
    <p class="text-xl font-semibold py-6 px-8 border-b">Pick your Recording language</p>
    <div class="px-8 py-6 flex flex-col gap-3">
      <div v-for="language in selectableLanguages" :key="language.value">
        <label :for="language.value">
          <input
            :id="language.value"
            v-model="store.selectedLanguageId"
            type="radio"
            name="language"
            :value="language.value"
          />
          <p>
            <b>{{ language.label }}</b>
          </p>
          <p>{{ language.description }}</p>
        </label>
      </div>
    </div>
  </div>
</template>

<script setup>
import { computed, watch, onMounted } from 'vue'
import { useRecordWizardStore } from '@/stores/recordwizard'
import { useLabelsStore } from '@/stores/labels'

const emit = defineEmits(['canGoToNextStep', 'canNotGoToNextStep'])

const store = useRecordWizardStore()
const labelsStore = useLabelsStore()

const proficiencies = {
  1: 'Beginner',
  2: 'Average',
  3: 'Good',
  4: 'Professional',
  5: 'Native',
}

const selectableLanguages = computed(() =>
  store.availableLanguages.map((lang) => {
    labelsStore.fetchLabelForWikidataItem(lang.language_qid)
    return {
      label: labelsStore.labels[lang.language_qid] ?? lang.language_qid,
      value: lang.language_qid,
      description: 'proficiency: ' + proficiencies[lang.proficiency],
    }
  }),
)

watch(
  () => store.selectedLanguageId,
  () => {
    emit('canGoToNextStep')
  },
)

onMounted(() => {
  store.selectedLanguageId && emit('canGoToNextStep')
})
</script>

<style scoped>
input[type='radio'] {
  display: none;
}
label {
  display: block;
  background-color: hsla(212, 9%, 66%, 0.6);
  border-radius: 10px;
  margin-bottom: 10px;
  padding: 10px;
  cursor: pointer;
}

label:has(input:checked) {
  background-color: #3366cc;
  color: white;
}
</style>
